//DJS 5_17_16

`timescale 1ps/1ps
module deserializer
(
	rx_start,
	clk,
	sdo,
   parallel_data,
	num_bits
);

input rx_start,clk,sdo,num_bits;
output parallel_data;

reg [15:0] parallel_data;
reg [5:0] cur_state,next_state;

wire rx_start;
wire [5:0] num_bits;

parameter bit_0 = 5'd0;
parameter bit_1 = 5'd1;
parameter bit_2 = 5'd2;
parameter bit_3 = 5'd3;
parameter bit_4 = 5'd4;
parameter bit_5 = 5'd5;
parameter bit_6 = 5'd6;
parameter bit_7 = 5'd7;
parameter bit_8 = 5'd8;
parameter bit_9 = 5'd9;
parameter bit_10 = 5'd10;
parameter bit_11 = 5'd11;
parameter bit_12 = 5'd12;
parameter bit_13 = 5'd13;
parameter bit_14 = 5'd14;
parameter bit_15 = 5'd15;

initial
  next_state = bit_15;
	
always @(negedge clk) //load the newest bit into the serial bit array on each rising edge of 'clk'
begin
	cur_state = next_state;		 		
	case (cur_state)
	
	bit_15:  //MSB first
	begin	
		if(rx_start)
      begin			
		  parallel_data[15] <= sdo;
	     next_state <= bit_14;
      end	
    else
      next_state <= bit_15;
   end
		
	bit_14:
   begin	
		parallel_data[14] <= sdo;
	 next_state <= bit_13;
   end	
    	
	bit_13:
   begin						
		parallel_data[13] <= sdo;		
	 next_state <= bit_12;
   end	
  	
	bit_12:
   begin						
		parallel_data[12] <= sdo;			
	 next_state <= bit_11;
   end	
  	
	bit_11:
   begin						
		parallel_data[11] <= sdo;		
	 next_state <= bit_10;
   end	
  	
	bit_10:
   begin						
		parallel_data[10] <= sdo;		
	 next_state <= bit_9;
   end	
  	
	bit_9:
   begin						
		parallel_data[9] <= sdo;
	 next_state <= bit_8;
   end	
  	
	bit_8:
   begin						
		parallel_data[8] <= sdo;		
	 next_state <= bit_7;
   end	
  	
	bit_7:
   begin						
		parallel_data[7] <= sdo;		
	 next_state <= bit_6;
   end	
  	
	bit_6:
   begin						
		parallel_data[6] <= sdo;	
	 next_state <= bit_5;
   end	
  	
	bit_5:
   begin						
		parallel_data[5] <= sdo;		
	 next_state <= bit_4;
   end	
    	
	bit_4:
   begin						
		parallel_data[4] <= sdo;
	 if(num_bits <= 6'd12)
		next_state <= bit_15;
	 else 
		next_state <= bit_3;
   end	
    	
	bit_3:
   begin					
		parallel_data[3] <= sdo;
		next_state <= bit_2;
   end	
    	
	bit_2:
   begin		
		parallel_data[2] <= sdo;		
		next_state = bit_1;
   end	
    	
	bit_1:
   begin						
		parallel_data[1] <= sdo;	
		next_state <= bit_0;
   end	
    	
	bit_0:  //LSB last
   begin	
		parallel_data[0] <= sdo;
		next_state <= bit_15;
	end	
	    
default 	: next_state <= bit_15;

endcase
end

endmodule